/* Text.c generated by valac 0.56.17, the Vala compiler
 * generated from Text.vala, do not modify */

/*
* Copyright 2021 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
*/

#include "desktop.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <granite-7.h>
#include <float.h>
#include <math.h>
#include <switchboard.h>
#include <gdk/gdk.h>

#define PANTHEON_SHELL_TEXT_DYSLEXIA_KEY "dyslexia-friendly-support"
#define PANTHEON_SHELL_TEXT_FONT_KEY "font-name"
#define PANTHEON_SHELL_TEXT_DOCUMENT_FONT_KEY "document-font-name"
#define PANTHEON_SHELL_TEXT_MONOSPACE_FONT_KEY "monospace-font-name"
#define PANTHEON_SHELL_TEXT_OD_REG_FONT "OpenDyslexic Regular 9"
#define PANTHEON_SHELL_TEXT_OD_DOC_FONT "OpenDyslexic Regular 10"
#define PANTHEON_SHELL_TEXT_OD_MON_FONT "OpenDyslexicMono Regular 10"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PANTHEON_SHELL_TEXT_0_PROPERTY,
	PANTHEON_SHELL_TEXT_NUM_PROPERTIES
};
static GParamSpec* pantheon_shell_text_properties[PANTHEON_SHELL_TEXT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PantheonShellTextPrivate {
	guint scale_timeout;
};

struct _Block3Data {
	int _ref_count_;
	PantheonShellText* self;
	GtkAdjustment* size_adjustment;
	GtkSwitch* dyslexia_font_switch;
	GSettings* interface_settings;
};

static gint PantheonShellText_private_offset;
static gpointer pantheon_shell_text_parent_class = NULL;

static GObject * pantheon_shell_text_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void _pantheon_shell_text___lambda50_ (Block3Data* _data3_);
static gboolean __lambda51_ (Block3Data* _data3_);
static gboolean ___lambda51__gsource_func (gpointer self);
static void __pantheon_shell_text___lambda50__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                     gpointer self);
static gboolean _pantheon_shell_text___lambda52_ (Block3Data* _data3_);
static gboolean __pantheon_shell_text___lambda52__gtk_switch_state_set (GtkSwitch* _sender,
                                                                 gboolean state,
                                                                 gpointer self);
static void pantheon_shell_text_finalize (GObject * obj);
static GType pantheon_shell_text_get_type_once (void);

static inline gpointer
pantheon_shell_text_get_instance_private (PantheonShellText* self)
{
	return G_STRUCT_MEMBER_P (self, PantheonShellText_private_offset);
}

PantheonShellText*
pantheon_shell_text_construct (GType object_type)
{
	PantheonShellText * self = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("preferences-desktop-font");
	_tmp1_ = _tmp0_;
	self = (PantheonShellText*) g_object_new (object_type, "title", _ ("Text"), "icon", _tmp1_, "show-end-title-buttons", TRUE, NULL);
	_g_object_unref0 (_tmp1_);
	return self;
}

PantheonShellText*
pantheon_shell_text_new (void)
{
	return pantheon_shell_text_construct (PANTHEON_SHELL_TYPE_TEXT);
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		PantheonShellText* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->interface_settings);
		_g_object_unref0 (_data3_->dyslexia_font_switch);
		_g_object_unref0 (_data3_->size_adjustment);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
__lambda51_ (Block3Data* _data3_)
{
	PantheonShellText* self;
	GSettings* _tmp0_;
	GtkAdjustment* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gboolean result;
	self = _data3_->self;
	self->priv->scale_timeout = (guint) 0;
	_tmp0_ = _data3_->interface_settings;
	_tmp1_ = _data3_->size_adjustment;
	_tmp2_ = gtk_adjustment_get_value (_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_double (_tmp0_, "text-scaling-factor", _tmp3_);
	result = FALSE;
	return result;
}

static gboolean
___lambda51__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda51_ (self);
	return result;
}

static void
_pantheon_shell_text___lambda50_ (Block3Data* _data3_)
{
	PantheonShellText* self;
	self = _data3_->self;
	if (self->priv->scale_timeout != ((guint) 0)) {
		g_source_remove (self->priv->scale_timeout);
	}
	self->priv->scale_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 300, ___lambda51__gsource_func, block3_data_ref (_data3_), block3_data_unref);
}

static void
__pantheon_shell_text___lambda50__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                gpointer self)
{
	_pantheon_shell_text___lambda50_ (self);
}

static gboolean
_pantheon_shell_text___lambda52_ (Block3Data* _data3_)
{
	PantheonShellText* self;
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
	self = _data3_->self;
	_tmp0_ = _data3_->dyslexia_font_switch;
	_tmp1_ = gtk_switch_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GSettings* _tmp3_;
		GSettings* _tmp4_;
		GSettings* _tmp5_;
		_tmp3_ = _data3_->interface_settings;
		g_settings_set_string (_tmp3_, PANTHEON_SHELL_TEXT_FONT_KEY, PANTHEON_SHELL_TEXT_OD_REG_FONT);
		_tmp4_ = _data3_->interface_settings;
		g_settings_set_string (_tmp4_, PANTHEON_SHELL_TEXT_DOCUMENT_FONT_KEY, PANTHEON_SHELL_TEXT_OD_DOC_FONT);
		_tmp5_ = _data3_->interface_settings;
		g_settings_set_string (_tmp5_, PANTHEON_SHELL_TEXT_MONOSPACE_FONT_KEY, PANTHEON_SHELL_TEXT_OD_MON_FONT);
	} else {
		GSettings* _tmp6_;
		GSettings* _tmp7_;
		GSettings* _tmp8_;
		_tmp6_ = _data3_->interface_settings;
		g_settings_reset (_tmp6_, PANTHEON_SHELL_TEXT_FONT_KEY);
		_tmp7_ = _data3_->interface_settings;
		g_settings_reset (_tmp7_, PANTHEON_SHELL_TEXT_DOCUMENT_FONT_KEY);
		_tmp8_ = _data3_->interface_settings;
		g_settings_reset (_tmp8_, PANTHEON_SHELL_TEXT_MONOSPACE_FONT_KEY);
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static gboolean
__pantheon_shell_text___lambda52__gtk_switch_state_set (GtkSwitch* _sender,
                                                        gboolean state,
                                                        gpointer self)
{
	gboolean result;
	result = _pantheon_shell_text___lambda52_ (self);
	return result;
}

static GObject *
pantheon_shell_text_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PantheonShellText * self;
	Block3Data* _data3_;
	GraniteHeaderLabel* size_label = NULL;
	GraniteHeaderLabel* _tmp0_;
	GtkAdjustment* _tmp1_;
	GtkScale* size_scale = NULL;
	GtkAdjustment* _tmp2_;
	GtkScale* _tmp3_ = NULL;
	GtkScale* _tmp4_;
	GtkScale* _tmp5_;
	GtkSpinButton* size_spinbutton = NULL;
	GtkAdjustment* _tmp6_;
	GtkSpinButton* _tmp7_;
	GtkGrid* size_grid = NULL;
	GtkGrid* _tmp8_ = NULL;
	GtkGrid* _tmp9_;
	GraniteHeaderLabel* _tmp10_;
	GtkGrid* _tmp11_;
	GtkScale* _tmp12_;
	GtkGrid* _tmp13_;
	GtkSpinButton* _tmp14_;
	GtkSwitch* _tmp15_ = NULL;
	GraniteHeaderLabel* dyslexia_font_label = NULL;
	GtkSwitch* _tmp16_;
	GtkWidget* _tmp17_;
	gchar* _tmp18_;
	GraniteHeaderLabel* _tmp19_ = NULL;
	GtkBox* dyslexia_box = NULL;
	GtkBox* _tmp20_;
	GtkBox* _tmp21_;
	GraniteHeaderLabel* _tmp22_;
	GtkBox* _tmp23_;
	GtkSwitch* _tmp24_;
	GtkBox* box = NULL;
	GtkBox* _tmp25_;
	GtkBox* _tmp26_;
	GtkGrid* _tmp27_;
	GtkBox* _tmp28_;
	GtkBox* _tmp29_;
	GtkBox* _tmp30_;
	GSettings* _tmp31_;
	GSettings* _tmp32_;
	GtkAdjustment* _tmp33_;
	GtkAdjustment* _tmp34_;
	gchar* interface_font = NULL;
	GSettings* _tmp35_;
	gchar* _tmp36_;
	gchar* document_font = NULL;
	GSettings* _tmp37_;
	gchar* _tmp38_;
	gchar* monospace_font = NULL;
	GSettings* _tmp39_;
	gchar* _tmp40_;
	gboolean _tmp41_ = FALSE;
	gboolean _tmp42_ = FALSE;
	const gchar* _tmp43_;
	GtkSwitch* _tmp46_;
	GtkSwitch* _tmp47_;
	parent_class = G_OBJECT_CLASS (pantheon_shell_text_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PANTHEON_SHELL_TYPE_TEXT, PantheonShellText);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = granite_header_label_new (_ ("Size"));
	g_object_ref_sink (_tmp0_);
	size_label = _tmp0_;
	_tmp1_ = gtk_adjustment_new ((gdouble) -1, 0.75, 1.5, 0.05, (gdouble) 0, (gdouble) 0);
	g_object_ref_sink (_tmp1_);
	_data3_->size_adjustment = _tmp1_;
	_tmp2_ = _data3_->size_adjustment;
	_tmp3_ = (GtkScale*) gtk_scale_new (GTK_ORIENTATION_HORIZONTAL, _tmp2_);
	gtk_scale_set_draw_value (_tmp3_, FALSE);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
	g_object_ref_sink (_tmp3_);
	size_scale = _tmp3_;
	_tmp4_ = size_scale;
	gtk_scale_add_mark (_tmp4_, (gdouble) 1, GTK_POS_TOP, NULL);
	_tmp5_ = size_scale;
	gtk_scale_add_mark (_tmp5_, 1.25, GTK_POS_TOP, NULL);
	_tmp6_ = _data3_->size_adjustment;
	_tmp7_ = (GtkSpinButton*) gtk_spin_button_new (_tmp6_, 0.25, (guint) 2);
	g_object_ref_sink (_tmp7_);
	size_spinbutton = _tmp7_;
	_tmp8_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp8_, 12);
	g_object_ref_sink (_tmp8_);
	size_grid = _tmp8_;
	_tmp9_ = size_grid;
	_tmp10_ = size_label;
	gtk_grid_attach (_tmp9_, (GtkWidget*) _tmp10_, 0, 0, 1, 1);
	_tmp11_ = size_grid;
	_tmp12_ = size_scale;
	gtk_grid_attach (_tmp11_, (GtkWidget*) _tmp12_, 0, 1, 1, 1);
	_tmp13_ = size_grid;
	_tmp14_ = size_spinbutton;
	gtk_grid_attach (_tmp13_, (GtkWidget*) _tmp14_, 1, 1, 1, 1);
	_tmp15_ = (GtkSwitch*) gtk_switch_new ();
	gtk_widget_set_valign ((GtkWidget*) _tmp15_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp15_);
	_data3_->dyslexia_font_switch = _tmp15_;
	_tmp16_ = _data3_->dyslexia_font_switch;
	_tmp17_ = _g_object_ref0 ((GtkWidget*) _tmp16_);
	_tmp18_ = g_strdup (_ ("Bottom-heavy shapes and increased character spacing can help improve l" \
"egibility and reading speed."));
	_tmp19_ = granite_header_label_new (_ ("Dyslexia-friendly"));
	gtk_widget_set_hexpand ((GtkWidget*) _tmp19_, TRUE);
	granite_header_label_set_mnemonic_widget (_tmp19_, _tmp17_);
	_g_object_unref0 (_tmp17_);
	granite_header_label_set_secondary_text (_tmp19_, _tmp18_);
	_g_free0 (_tmp18_);
	g_object_ref_sink (_tmp19_);
	dyslexia_font_label = _tmp19_;
	_tmp20_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
	g_object_ref_sink (_tmp20_);
	dyslexia_box = _tmp20_;
	_tmp21_ = dyslexia_box;
	_tmp22_ = dyslexia_font_label;
	gtk_box_append (_tmp21_, (GtkWidget*) _tmp22_);
	_tmp23_ = dyslexia_box;
	_tmp24_ = _data3_->dyslexia_font_switch;
	gtk_box_append (_tmp23_, (GtkWidget*) _tmp24_);
	_tmp25_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 24);
	g_object_ref_sink (_tmp25_);
	box = _tmp25_;
	_tmp26_ = box;
	_tmp27_ = size_grid;
	gtk_box_append (_tmp26_, (GtkWidget*) _tmp27_);
	_tmp28_ = box;
	_tmp29_ = dyslexia_box;
	gtk_box_append (_tmp28_, (GtkWidget*) _tmp29_);
	_tmp30_ = box;
	switchboard_settings_page_set_child ((SwitchboardSettingsPage*) self, (GtkWidget*) _tmp30_);
	_tmp31_ = g_settings_new ("org.gnome.desktop.interface");
	_data3_->interface_settings = _tmp31_;
	_tmp32_ = _data3_->interface_settings;
	_tmp33_ = _data3_->size_adjustment;
	g_settings_bind (_tmp32_, "text-scaling-factor", (GObject*) _tmp33_, "value", G_SETTINGS_BIND_GET);
	_tmp34_ = _data3_->size_adjustment;
	g_signal_connect_data (_tmp34_, "value-changed", (GCallback) __pantheon_shell_text___lambda50__gtk_adjustment_value_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp35_ = _data3_->interface_settings;
	_tmp36_ = g_settings_get_string (_tmp35_, PANTHEON_SHELL_TEXT_FONT_KEY);
	interface_font = _tmp36_;
	_tmp37_ = _data3_->interface_settings;
	_tmp38_ = g_settings_get_string (_tmp37_, PANTHEON_SHELL_TEXT_DOCUMENT_FONT_KEY);
	document_font = _tmp38_;
	_tmp39_ = _data3_->interface_settings;
	_tmp40_ = g_settings_get_string (_tmp39_, PANTHEON_SHELL_TEXT_MONOSPACE_FONT_KEY);
	monospace_font = _tmp40_;
	_tmp43_ = interface_font;
	if (g_strcmp0 (_tmp43_, PANTHEON_SHELL_TEXT_OD_REG_FONT) == 0) {
		_tmp42_ = TRUE;
	} else {
		const gchar* _tmp44_;
		_tmp44_ = document_font;
		_tmp42_ = g_strcmp0 (_tmp44_, PANTHEON_SHELL_TEXT_OD_DOC_FONT) == 0;
	}
	if (_tmp42_) {
		_tmp41_ = TRUE;
	} else {
		const gchar* _tmp45_;
		_tmp45_ = monospace_font;
		_tmp41_ = g_strcmp0 (_tmp45_, PANTHEON_SHELL_TEXT_OD_MON_FONT) == 0;
	}
	_tmp46_ = _data3_->dyslexia_font_switch;
	gtk_switch_set_active (_tmp46_, _tmp41_);
	_tmp47_ = _data3_->dyslexia_font_switch;
	g_signal_connect_data (_tmp47_, "state-set", (GCallback) __pantheon_shell_text___lambda52__gtk_switch_state_set, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_g_free0 (monospace_font);
	_g_free0 (document_font);
	_g_free0 (interface_font);
	_g_object_unref0 (box);
	_g_object_unref0 (dyslexia_box);
	_g_object_unref0 (dyslexia_font_label);
	_g_object_unref0 (size_grid);
	_g_object_unref0 (size_spinbutton);
	_g_object_unref0 (size_scale);
	_g_object_unref0 (size_label);
	block3_data_unref (_data3_);
	_data3_ = NULL;
	return obj;
}

static void
pantheon_shell_text_class_init (PantheonShellTextClass * klass,
                                gpointer klass_data)
{
	pantheon_shell_text_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PantheonShellText_private_offset);
	G_OBJECT_CLASS (klass)->constructor = pantheon_shell_text_constructor;
	G_OBJECT_CLASS (klass)->finalize = pantheon_shell_text_finalize;
}

static void
pantheon_shell_text_instance_init (PantheonShellText * self,
                                   gpointer klass)
{
	self->priv = pantheon_shell_text_get_instance_private (self);
}

static void
pantheon_shell_text_finalize (GObject * obj)
{
	PantheonShellText * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PANTHEON_SHELL_TYPE_TEXT, PantheonShellText);
	G_OBJECT_CLASS (pantheon_shell_text_parent_class)->finalize (obj);
}

static GType
pantheon_shell_text_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PantheonShellTextClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pantheon_shell_text_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PantheonShellText), 0, (GInstanceInitFunc) pantheon_shell_text_instance_init, NULL };
	GType pantheon_shell_text_type_id;
	pantheon_shell_text_type_id = g_type_register_static (SWITCHBOARD_TYPE_SETTINGS_PAGE, "PantheonShellText", &g_define_type_info, 0);
	PantheonShellText_private_offset = g_type_add_instance_private (pantheon_shell_text_type_id, sizeof (PantheonShellTextPrivate));
	return pantheon_shell_text_type_id;
}

GType
pantheon_shell_text_get_type (void)
{
	static volatile gsize pantheon_shell_text_type_id__once = 0;
	if (g_once_init_enter (&pantheon_shell_text_type_id__once)) {
		GType pantheon_shell_text_type_id;
		pantheon_shell_text_type_id = pantheon_shell_text_get_type_once ();
		g_once_init_leave (&pantheon_shell_text_type_id__once, pantheon_shell_text_type_id);
	}
	return pantheon_shell_text_type_id__once;
}

